Title: Participation

## Introduction

Every volunteer project obtains its strength from the people involved in it. We invite you to participate as much or as little as you choose. The roles and responsibilities that people can assume in the project are based on merit. Everybody's input matters!

There are a variety of ways to participate. Regardless of how you choose to participate, we suggest you join some or all of our mailing lists.

## Use the Products & Give Us Feedback

Using the products,reporting bugs, making feature requests, etc. is by far the most important role. It's your feedback that allows the technology to evolve.

 - Join Mailing Lists
 - [Download Binary Builds](releases.html)
 - [Report Bugs & Request New Features](https://issues.apache.org/jira/browse/JUDDI)

## Contribute Code or Documentation Patches

In this role, you participate in the actual development of the code. If this is the type of role you'd like to play, here are some steps (in addition to the ones above) to get you started:

 - Read Mailing List Guidelines
 - Review Reference Library
 - [Get the Source Code](source.html)
  
Any and all new development or bug fixing uses the latest code base. If you have a patch, it should be submitted against the latest available code.

### Coding Standards

Here's some basic coding standards that are followed for jUDDI's code base.
 
 - Tab sizes, 8 spaces
 - Document formatting - use your IDE's auto format feature to automatically format documents
 - Documentation
   - Java
     - Use javadoc style documentation for Java code
     - Mandatory documentation on all public methods and constants
     - Mandatory documentation on each class.
     - Include @author, @since, and @see as often as possible
     - Include email address with @author
	 - Include sample code where appropriate
	 - Use HTML formatting to aid readability
   - .NET
     - Use .NET style documentation when possible
	 - For ported Java code, javadoc style documentation is acceptable
	 - Use standard .NET tab sizes

## Getting Support on the Lists

We do all development and bug fixing on the latest available code base. If you've encountered what you think is a bug, please first check the [issues database](https://issues.apache.org/jira/browse/JUDDI) for known issues. If you can't find your bug, make sure you're using the latest code base. We are not able to fix bugs on earlier code bases.

Please include any relevant version information and the error message text, if there is one. If you have a problem with a specific interface, like find_business, you'll likely be asked to post a log of the SOAP message exchanges between your client and the jUDDI server. You can use the [Apache TCPMon](http://ws.apache.org/tcpmon/) tool to capture these messages.

Remember, Apache helps those that help themselves. Please take a look at Eric S. Raymond's and Rick Moen's explanation of [How to Ask Questions The Smart Way](http://www.catb.org/~esr/faqs/smart-questions.html).

## jUDDI Wiki

Like other Apache projects, jUDDI maintains a wiki, a sort of virtual meeting place for the jUDDI community. This is a resource available to everyone, and you are encouraged to contribute. This is a good resource for 'HowTos' for common configuration issues.

 - [http://wiki.apache.org/juddi](http://wiki.apache.org/juddi)